﻿#define USE_EXPLICIT_CCTOR1

using System;

namespace ConsoleApp1
{
    static class Program
    {
        static MyStatic _instance = new MyStatic();

        static void Main(string[] args)
        {
            Console.WriteLine(".NET Core!");
        }

#if USE_EXPLICIT_CCTOR
        static Program()
        {
        }
#endif
    }
}

internal class MyStatic
{
    static MyStaticLevel2 _instance = new MyStaticLevel2();

    public MyStatic()
    {
        Console.WriteLine("MyStatic.ctor");
    }

#if USE_EXPLICIT_CCTOR
    static MyStatic()
    {
    }
#endif
}

internal class MyStaticLevel2
{
    public MyStaticLevel2()
    {
        Console.WriteLine("MyStaticLevel2.ctor");
    }
}